<?php


namespace App\Operations;


use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;
use Symfony\Component\DependencyInjection\Tests\Fixtures\StdClassDecorator;
use Zend\Stdlib\ArrayObject;

class Configuration extends RecursiveArrayObject implements ConfigurationInterface
{
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder('mattermost-documentation-bot');

        $treeBuilder->getRootNode()
            ->children()
                ->booleanNode('debug')
                    ->info('Whether to show debugging information on errors. Disable on production.')
                    ->example(false)
                ->end()
                ->arrayNode('watch')
                    ->children()
                        ->arrayNode('directories')
                            ->info('The IDs of the Google Drive directories to watch for reports.\
                            The ID of a directory is the string displayed on its URL.')
                            ->example([ '1r8J41k13frjalz4i1rj1464jg0' ])
                            ->scalarPrototype()->end()
                        ->end()
                        ->booleanNode('disable')
                            ->info('Whether to disable reacting to watch notifications')
                            ->defaultFalse()
                        ->end()
                    ->end()
                ->end()
                ->scalarNode('url')
                    ->info('The URL to the mattermost-documentation-bot folder')
                    ->example('https://example.com/mm-doc-bot/')
                    ->beforeNormalization()
                        ->always(function ($v) { return rtrim($v , '/'); }) // Remove trailing slash
                    ->end()
                ->end()
                ->scalarNode('target_directory')
                    ->info('The structured directory where documentation files will be copied')
                    ->example('1r8J41k13frjalz4i1rj1464jg0')
                ->end()
                ->variableNode('strictDate')
                    ->info('All reports pushed after this date will be required to have XMP data')
                    ->example('01/01/2019')
                    ->beforeNormalization()
                        ->always(function ($v) { return new \DateTime($v); }) // Convert string to DateTime
                    ->end()
                ->end()
                ->scalarNode('lenientCategory')
                    ->info('A category of documents that does not require having valid XMP data, regardless of strictDate')
                    ->example('O')
                    ->defaultNull()
                ->end()
                ->arrayNode('mattermost')
                    ->children()
                        ->scalarNode('incoming_hook')
                            ->info('The incoming hook URL of the Mattermost instance')
                            ->example('https://my.mattermost.instance.org/hooks/a8gnabafk4lz984jzboejwi49o')
                        ->end()
                        ->scalarNode('sandbox_channel')
                            ->info('A channel where test Mattermost messages will be sent')
                            ->defaultValue('sandbox')
                        ->end()
                        ->scalarNode('token')
                            ->info('A personal access token for a Mattermost account to fetch useful data')
                        ->end()
                        ->scalarNode('url')
                            ->info('The URL of the Mattermost instance')
                            ->example('https://mattermost.example.com')
                            ->beforeNormalization()
                                ->always(function ($v) { return rtrim($v , '/'); }) // Remove trailing slash
                            ->end()
                        ->end()
                        ->arrayNode('notifications')
                            ->info('A list of channels to send SYE notifications about events to')
                            ->example(['sye_notifications', '@admin'])
                            ->scalarPrototype()->end()
                        ->end()
                        ->arrayNode('channels')
                            ->info('An associative list of Subsystem IDs => mattermost channel aliases, to associate each subsystem with its channel')
                            ->example([
                                'ADC' => 'adcs',
                                'COM' => 'comms',
                                'STR' => 'structure-channel'
                            ])
                            ->scalarPrototype()->end()
                        ->end()
                        ->arrayNode('oauth')
                            ->info('Configuration for the Mattermost OAuth authentication. Set to null to disable.')
                            ->canBeEnabled()
                            ->children()
                                ->scalarNode('client_id')
                                    ->info('The OAuth Client ID')->example('j1byp6fdmo33rrqb8ba5zmo4rb')
                                ->end()
                                ->scalarNode('client_secret')
                                    ->info('The OAuth Client Secret')->example('kddf1pho1fwy7nhyru4b5xv3d8')
                                ->end()
                            ->end()
                        ->end()
                        ->arrayNode('allowed_teams')
                            ->info('A list of team names that are allowed full access to the documentation')
                            ->example(['company', 'corporate-sponsors'])
                            ->scalarPrototype()->end()
                        ->end()
                        ->arrayNode('allowed_users')
                            ->info('A list of usernames that are allowed full access to the documentation')
                            ->example(['ceo', 'mandy', 'john'])
                            ->scalarPrototype()->end()
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('gitlab')
                    ->info('Information about Gitlab repositories associated with the documentation')
                    ->children()
                        ->scalarNode('template_repo')
                            ->info('The Gitlab path to the Project holding the documentation template')
                            ->example('acubesat/templates/documentation-template')
                        ->end()
                        ->scalarNode('token')
                            ->info('Your personal Gitlab token')
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('ldap')
                    ->info('Information about the LDAP database')
                    ->children()
                        ->scalarNode('host')
                            ->info('The LDAP host address')
                            ->example('ACME-DC01.corp.acme.org:1389')
                        ->end()
                        ->scalarNode('baseDn')
                            ->info('The base distinguished name of your domain to perform searches upon.')
                            ->example('dc=corp,dc=acme,dc=org')
                        ->end()
                        ->scalarNode('username')
                            ->info('The username of a user thas has read access to the user accounts')
                            ->example('admin')
                        ->end()
                        ->scalarNode('password')
                            ->info('The password of the above user')
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('tokens')
                    ->info('Various permanent tokens to be used by different services')
                    ->children()
                        ->arrayNode('login')
                            ->info('Tokens that allow special users to enter by URL')
                            ->example(['e0J1FUdGTLosBWXK', 'IWOQdWExmC1pyDKx'])
                            ->scalarPrototype()->end()
                        ->end()
                    ->end()
            ->end();

        return $treeBuilder;
    }
}
